package com.example.autorization.ui.adapters

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.cardview.widget.CardView
import androidx.recyclerview.widget.RecyclerView.Adapter
import androidx.recyclerview.widget.RecyclerView.ViewHolder
import com.example.autorization.R
import com.example.autorization.ui.fragments.signup.User

class UserAdapter(): Adapter<UserAdapter.UserViewHolder>() {

    private val _users:MutableList<User> = mutableListOf<User>()
    var OnClick:((index:Int, view:View) -> Unit)? = null

    fun setList(user: List<User>){
        _users.addAll(user.toMutableList());
    }

    inner class UserViewHolder(view: View):ViewHolder(view) {
        val userNameTextView = view.findViewById<TextView>(R.id.UserNameTextView)
        val userEmailTextView = view.findViewById<TextView>(R.id.UserEmailTextView)
        val userPasswordTextView = view.findViewById<TextView>(R.id.UserPasswordTextView)
        val userCardView = view.findViewById<CardView>(R.id.UserCardView)

        init{
            userCardView.setOnClickListener {
                OnClick?.invoke(adapterPosition, view)
            }
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): UserViewHolder {
        return UserViewHolder(LayoutInflater.from(parent.context)
            .inflate(R.layout.user_item, parent, false))
    }
    fun addUser(user:User){
        _users.add(0, user)
        notifyItemInserted(0)
    }
    fun deleteUserById(index: Int){
        _users.removeAt(index)
        notifyItemRemoved(index)
    }

    override fun getItemCount(): Int = _users.size

    override fun onBindViewHolder(holder: UserViewHolder, position: Int) {
        holder.userNameTextView.text = _users[position].name
        holder.userEmailTextView.text = _users[position].email
        holder.userPasswordTextView.text = _users[position].password
    }
}