package com.example.autorization.ui.adapters

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.cardview.widget.CardView
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import androidx.recyclerview.widget.RecyclerView.LayoutManager
import com.example.autorization.R
import com.example.autorization.ui.fragments.signup.User

class UserAdapterDiffUtils: ListAdapter<User, UserAdapterDiffUtils.UserViewHolder>(UserDiffCallback) {

    var OnLongClick: ((User) -> Unit)? = null
    inner  class UserViewHolder(view:View): RecyclerView.ViewHolder(view) {
        val userNameTextView = view.findViewById<TextView>(R.id.UserNameTextView)
        val userEmailTextView = view.findViewById<TextView>(R.id.UserEmailTextView)
        val userPasswordTextView = view.findViewById<TextView>(R.id.UserPasswordTextView)
        val userCardView = view.findViewById<CardView>(R.id.UserCardView)

        fun bind(user: User){
            userEmailTextView.text = user.email
            userNameTextView.text = user.name
            userPasswordTextView.text = user.password
            userCardView.setOnClickListener {
                OnLongClick?.invoke(user)
            }
        }
    }

    object UserDiffCallback: DiffUtil.ItemCallback<User>(){
        override fun areItemsTheSame(oldItem: User, newItem: User): Boolean {
            return oldItem == newItem
        }

        override fun areContentsTheSame(oldItem: User, newItem: User): Boolean {
            return oldItem.email == newItem.email
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): UserViewHolder {
        return UserViewHolder(LayoutInflater
            .from(parent.context)
            .inflate(R.layout.user_item, parent, false)
        )
     }

    override fun onBindViewHolder(holder: UserViewHolder, position: Int) {
        val user = getItem(position)
        holder.bind(user)
    }
}