package com.example.autorization.ui.fragments.signup

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel

class SignUpViewModel:ViewModel() {
    private var _signUpState: MutableLiveData<SignUpState> = MutableLiveData(SignUpState())
    val signUpState : LiveData<SignUpState> = _signUpState

    private val users : MutableList<User> = mutableListOf()

    fun registrationUser():User?{
        if (_signUpState.value == null) return null
        if(_signUpState.value!!.name.isBlank())
        {
            _signUpState.postValue(_signUpState.value!!.copy(
                errorMessage = "Пустое имя пользователя")
            )
            return null
        }
        if(_signUpState.value!!.login.isBlank()){
            _signUpState.postValue(_signUpState.value!!.copy(
                errorMessage = "Пустой логин")
            )
            return null
        }
        if(_signUpState.value!!.password.isBlank()) {
            _signUpState.postValue(_signUpState.value!!.copy(
                errorMessage = "Пустой пароль")
            )
            return null
        }
        if(_signUpState.value!!.login.contains('@')) {
           val user = User(
                email = _signUpState.value!!.login,
                name = _signUpState.value!!.name,
                password = _signUpState.value!!.password
            )
            return user
        }
        val user =User(
            number = _signUpState.value!!.login,
            name = _signUpState.value!!.name,
            password = _signUpState.value!!.password
        )
        return user
    }

    fun setError(error:String) {
        _signUpState.postValue(_signUpState.value?.copy(errorMessage = error))
    }

    fun setPassword(password:String) {
        _signUpState.postValue(_signUpState.value?.copy(password = password))
    }
    fun setName(name:String) {
        _signUpState.postValue(_signUpState.value?.copy(name = name))
    }

    fun setLogin(login:String) {
        _signUpState.postValue(_signUpState.value?.copy(login = login))
    }
    fun changeTerms(isAccept:Boolean) {
        _signUpState.postValue(_signUpState.value?.copy(acceptTerms = isAccept))
    }
}