package com.example.autorization.ui.fragments.users

import android.os.Bundle
import android.view.View
import android.widget.Button
import android.widget.PopupMenu
import androidx.fragment.app.Fragment
import androidx.fragment.app.activityViewModels
import androidx.fragment.app.commit
import androidx.fragment.app.replace
import androidx.fragment.app.viewModels
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.example.autorization.R
import com.example.autorization.ui.adapters.UserAdapter
import com.example.autorization.ui.adapters.UserAdapterDiffUtils
import com.example.autorization.ui.fragments.edituser.EditUserFragment
import com.example.autorization.ui.fragments.signup.SignUpScreen
import com.example.autorization.ui.fragments.signup.SignUpState
import com.example.autorization.ui.fragments.signup.User


class UsersFragment : Fragment(R.layout.fragment_users) {

    val viewModel by activityViewModels<UserViewModel>()

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        val recyclerView = view.findViewById<RecyclerView>(R.id.UserRecyclerView)
        val createUserButton = view.findViewById<Button>(R.id.CreateAccountButton)


        createUserButton.setOnClickListener {
            viewModel.removeUserByPosition(0)
        }


        recyclerView.layoutManager = LinearLayoutManager(requireContext())

        val userAdapterDiffUtils = UserAdapterDiffUtils()

        recyclerView.adapter = userAdapterDiffUtils

        viewModel.users.observe(viewLifecycleOwner){
            userAdapterDiffUtils.submitList(it as MutableList<User>)
        }
        userAdapterDiffUtils.OnLongClick = { user ->
            val editUserFragment = EditUserFragment(user)
            parentFragmentManager.commit {
                replace(R.id.fragment_container_view, editUserFragment)
            }
        }


    }


    private fun showMenu(
        view:View,
         index:Int){
       PopupMenu(requireContext(), view).apply {
           setOnMenuItemClickListener { item ->
               when (item?.itemId) {
                   R.id.DeleteAction -> {
                       viewModel.removeUserByPosition(index)
                       true
                   }
                   else -> true
               }
           }
           inflate(R.menu.user_action_menu)
           show()
       }


    }
}